openapi: '3.0.2'
info:
  title: RCF RIBA
  version: '0.1'
servers:
  - url: http://localhost:7778/api
    description: Local development server
  - url: https://riba.risis.io/api/v0
tags:
  - name: "Projects"
    description: ""
  - name: "Project resources"
    description: ""
  - name: "Datasets"
    description: ""
  - name: "Scenarios"
    description: ""
  - name: "Jobs"
    description: ""
  - name: "Users"
    description: ""
  - name: "Notifications"
    description: ""
  - name: "Access Requests"
paths:
  /users/stats:
    get:
      tags:
        - "Users"
      summary: stats of the user
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/user.yml#/components/schemas/Stats'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /users/profile/{userId}:
    get:
      tags:
        - "Users"
      summary: User information
      security:
        - BearerAuth: ['Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/user.yml#/components/schemas/DisplayUserModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /users/profile/email/{userId}:
    get:
      tags:
        - "Users"
      summary: User information by Email
      security:
        - BearerAuth: ['Local Admin', 'Super Admin', 'Service']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/user.yml#/components/schemas/DisplayUserModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /users/profile:
    get:
      tags:
        - "Users"
      summary: User information
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/user.yml#/components/schemas/DisplayUserModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /users/service/credentials:
    post:
      tags:
        - "Users"
      summary: Creating service credentials
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      requestBody:
        description: The credential to be added
        content:
          application/json:
            schema:
              $ref: './schemas/user.yml#/components/schemas/CreateProviderCredential'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/user.yml#/components/schemas/DisplayUserModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /users/service/credentials/{serviceId}:
    patch:
      tags:
        - "Users"
      summary: Update service credentials
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      requestBody:
        description: The credential to be added
        content:
          application/json:
            schema:
              $ref: './schemas/user.yml#/components/schemas/UpdateProviderCredential'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/user.yml#/components/schemas/DisplayUserModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /projects:
    get:
      tags:
        - "Projects"
      summary: List projects
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      parameters:
        - $ref: "#/components/parameters/limitParam"
        - $ref: "#/components/parameters/offsetParam"
        - $ref: "#/components/parameters/searchParam"
        - $ref: "#/components/parameters/searchMatchParam"
        - $ref: "#/components/parameters/searchInParam"
        - $ref: "#/components/parameters/searchOrderParam"
        - $ref: "#/components/parameters/searchDirParam"
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/project.yml#/components/schemas/ArrayOfProjectDetail'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    post:
      tags:
        - "Projects"
      summary: Create new project
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      requestBody:
        description: The project to be added
        content:
          application/json:
            schema:
              $ref: './schemas/project.yml#/components/schemas/InsertProjectModel'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/project.yml#/components/schemas/ProjectFull'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /projects/{projectId}:
    parameters:
    - name: projectId
      in: path
      description: ID of project
      required: true
      schema:
        type: string
    get:
      tags:
        - "Projects"
      parameters:
        - in: query
          name: view
          required: false
          schema:
            type: string
            default: full
            enum:
              - summary
              - full
          description: The view of the project
          allowEmptyValue: false
          examples:
            full:
              summary: Full view
              value: full
            summary:
              summary: Summary view
              value: summary
      summary: Retrieve a project's information
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/project.yml#/components/schemas/ProjectFull'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    patch:
      tags:
        - "Projects"
      summary: Update a project
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      requestBody:
        description: The project to be added
        content:
          application/json:
            schema:
              $ref: './schemas/project.yml#/components/schemas/UpdateProject'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/project.yml#/components/schemas/ProjectFull'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    delete:
      tags:
        - "Projects"
      summary: Delete a project and his jobs
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/project.yml#/components/schemas/ProjectFull'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /projects/{projectId}/run:
    parameters:
    - name: projectId
      in: path
      description: ID of project
      required: true
      schema:
        type: string
    post:
      tags:
        - "Projects"
      summary: Run a main scenario of a project
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      requestBody:
        description: Run a main scenario of a project
        content:
          application/json:
            schema:
              $ref: './schemas/scenario.yml#/components/schemas/RunScenario'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/scenario.yml#/components/schemas/DisplayScenarioModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /projects/{projectId}/scenarios:
    get:
      tags:
        - "Project resources"
      summary: Retrieve a project's scenarios
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/scenario.yml#/components/schemas/ArrayOfDisplayScenario'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    parameters:
    - name: projectId
      in: path
      description: ID of project
      required: true
      schema:
        type: string
  /projects/{projectId}/scenarios/{scenarioId}:
    get:
      tags:
        - "Project scenario instances"
      summary: Get a scenario instance from a project
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: "./schemas/scenario.yml#/components/schemas/DisplayScenarioModel"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    put:
      tags:
        - "Project resources"
      summary: Import a scenario into a project
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: "./schemas/scenario.yml#/components/schemas/DisplayScenarioModel"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    delete:
      tags:
        - "Project resources"
      summary: Unlink scenario from project
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          $ref: "#/components/responses/Success"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    parameters:
    - name: projectId
      in: path
      description: ID of project
      required: true
      schema:
        type: string
    - name: scenarioId
      in: path
      description: ID of scenario to import
      required: true
      schema:
        type: string
  /projects/{projectId}/scenarios/{scenarioId}/run:
    parameters:
    - name: projectId
      in: path
      description: ID of project
      required: true
      schema:
        type: string
    - name: scenarioId
      in: path
      description: ID of scenario
      required: true
      schema:
        type: string
    post:
      tags:
        - "Projects"
      summary: Run a scenario
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      requestBody:
        description: Run a scenario
        content:
          application/json:
            schema:
              $ref: './schemas/scenario.yml#/components/schemas/RunScenario'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/scenario.yml#/components/schemas/DisplayScenarioModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /projects/{projectId}/jobs:
    parameters:
    - name: projectId
      in: path
      description: ID of the project
      required: true
      schema:
        type: string
    get:
      tags:
        - "Jobs"
      summary: Get a list of jobs by project
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/job.yml#/components/schemas/ArrayOfDisplayJob'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /projects/{projectId}/scenarios/{scenarioId}/job:
    patch:
      tags:
        - "Project resources"
      summary: Change title of the last scenario job
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          $ref: "#/components/responses/Success"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
      parameters:
      - name: projectId
        in: path
        description: ID of project
        required: true
        schema:
          type: string
      - name: scenarioId
        in: path
        description: ID of scenario
        required: true
        schema:
          type: string
  /projects/{projectId}/scenarios/{scenarioId}/config:
    get:
      tags:
        - "Project resources"
      summary: Get a scenario configuration
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          $ref: "#/components/responses/Success"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
      parameters:
      - name: projectId
        in: path
        description: ID of project
        required: true
        schema:
          type: string
    patch:
      tags:
        - "Project resources"
      summary: Update a configuration of a scenario
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          $ref: "#/components/responses/Success"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
      parameters:
      - name: projectId
        in: path
        description: ID of project
        required: true
        schema:
          type: string
      - name: scenarioId
        in: path
        description: ID of scenario
        required: true
        schema:
          type: string
  /projects/{projectId}/scenarios/{scenarioId}/actions:
    post:
      tags:
        - "Project"
        - "Scenario"
        - "Stop"
        - "Actions"
      summary: Perform an action on a scenario
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      requestBody:
        content:
          application/json; charset=utf-8:
            schema:
              type: object
              properties:
                command:
                  type: string
                  enum:
                    - STOP
      responses:
        '200':
          $ref: "#/components/responses/Success"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
      parameters:
      - name: projectId
        in: path
        description: ID of project
        required: true
        schema:
          type: string
      - name: scenarioId
        in: path
        description: ID of scenario
        required: true
        schema:
          type: string
  /scenarios/{scenarioId}/presets:
    get:
      tags:
        - "Project resources"
      summary: Get a presets information
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
      parameters:
      - name: scenarioId
        in: path
        description: ID of scenario
        required: true
        schema:
          type: string
    post:
      tags:
        - "Project resources"
      summary: Create a preset
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          $ref: "#/components/responses/Success"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
      parameters:
      - name: scenarioId
        in: path
        description: ID of scenario
        required: true
        schema:
          type: string
  /scenarios/{scenarioId}/presets/{presetId}:
    delete:
      tags:
        - "Project resources"
      summary: Delete a presets information
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          $ref: "#/components/responses/Success"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
      parameters:
      - name: scenarioId
        in: path
        description: ID of scenario
        required: true
        schema:
          type: string
      - name: presetId
        in: path
        description: ID of preset
        required: true
        schema:
          type: string
    patch:
      tags:
        - "Project resources"
      summary: Update a preset
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          $ref: "#/components/responses/Success"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
      parameters:
      - name: scenarioId
        in: path
        description: ID of scenario
        required: true
        schema:
          type: string
      - name: presetId
        in: path
        description: ID of preset
        required: true
        schema:
          type: string
  /projects/{projectId}/datasets:
    get:
      tags:
        - "Project resources"
      summary: Retrieve a project's imported datasets
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/dataset.yml#/components/schemas/ArrayOfDisplayDataset'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    parameters:
    - name: projectId
      in: path
      description: ID of project
      required: true
      schema:
        type: string
  /projects/{projectId}/datasets/{datasetId}:
    put:
      tags:
        - "Project resources"
      summary: Import a dataset into the project
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin', 'Service']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: "./schemas/project.yml#/components/schemas/ProjectFull"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    delete:
      tags:
        - "Project resources"
      summary: Remove dataset from project
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          $ref: "#/components/responses/Success"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    parameters:
    - name: projectId
      in: path
      description: ID of project
      required: true
      schema:
        type: string
    - name: datasetId
      in: path
      description: Result of appling encodeURIComponent Javascript function on the ID of the dataset
      example: 'doi%3A10.5072%2FRS3%2FGTM4HU'
      required: true
      schema:
        type: string
  /projects/{projectId}/jobs/{jobId}/outputs:
    parameters:
    - name: projectId
      in: path
      description: ID of project
      required: true
      schema:
        type: string
    - name: jobId
      in: path
      description: ID of job
      required: true
      schema:
        type: string
    get:
      tags:
        - "Project resources"
      summary: Download outputs files as a zip file
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          $ref: "#/components/responses/File"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /datasets:
    get:
      tags:
        - "Datasets"
      summary: Get list of datasets
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/dataset.yml#/components/schemas/ArrayOfDisplayDataset'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    post:
      tags:
        - "Datasets"
      summary: Create new Dataset
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      requestBody:
        description: Dataset to be created
        required: true
        content:
          multipart/form-data:
            schema:
              $ref: './schemas/dataset.yml#/components/schemas/InsertDatasetModel'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/dataset.yml#/components/schemas/DisplayDatasetModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /datasets/{datasetId}:
    parameters:
    - name: datasetId
      in: path
      description: Result of appling encodeURIComponent Javascript function on the ID of the dataset
      example: 'doi%3A10.5072%2FRS3%2FGTM4HU'
      required: true
      schema:
        type: string
    get:
      tags:
        - "Datasets"
      summary: Get a dataset with full information
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/dataset.yml#/components/schemas/FullDataset'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    patch:
      tags:
        - "Datasets"
      summary: Update a dataset
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      requestBody:
        description: Dataset to be created
        content:
          application/json:
            schema:
              $ref: './schemas/dataset.yml#/components/schemas/UpdateDatasetModel'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/dataset.yml#/components/schemas/FullDataset'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    delete:
      tags:
        - "Datasets"
      summary: Delete a dataset
      security:
        - BearerAuth: ['Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/dataset.yml#/components/schemas/FullDataset'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /datasets/{datasetId}/files:
    parameters:
    - name: datasetId
      in: path
      description: Result of appling encodeURIComponent Javascript function on the ID of the dataset
      example: 'doi%3A10.5072%2FRS3%2FGTM4HU'
      required: true
      schema:
        type: string
    get:
      tags:
        - "Datasets"
      summary: Download dataset files as a zip file
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          $ref: "#/components/responses/File"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    post:
      tags:
        - "Datasets"
      summary: Add file to dataset
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      requestBody:
        content:
          multipart/form-data:
            schema:
              properties:
                files:
                  type: array
                  items:
                    type: string
                    format: binary
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/job.yml#/components/schemas/FilesUploaded'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /datasets/{datasetId}/files/{fileId}/metadata:
    parameters:
    - name: datasetId
      in: path
      description: Result of appling encodeURIComponent Javascript function on the ID of the dataset
      example: 'doi%3A10.5072%2FRS3%2FGTM4HU'
      required: true
      schema:
        type: string
    - name: fileId
      in: path
      description: Id of the file
      example: '25'
      required: true
      schema:
        type: string
    get:
      tags:
        - "Datasets"
        - "Files"
        - "Metadata"
      summary: Retrieve dataset file metadata
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/dataset.yml#/components/schemas/FileMetadata'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /scenarios:
    get:
      tags:
        - "Scenarios"
      summary: Get list of scenarios
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/scenario.yml#/components/schemas/ArrayOfDisplayScenario'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /scenarios/{scenarioId}:
    get:
      tags:
        - "Scenarios"
      summary: Get a scenario with full information
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/scenario.yml#/components/schemas/DisplayScenarioModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
      parameters:
      - name: scenarioId
        in: path
        description: ID of scenario
        required: true
        schema:
          type: string
  /scenarios/{scenarioId}/projects:
    get:
      tags:
        - "Scenarios"
      summary: Get array of projects using the interface of scenario
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      parameters:
        - name: scenarioId
          in: path
          description: ID of scenario
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/project.yml#/components/schemas/ArrayOfProjectDetail'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /jobs:
    get:
      tags:
        - "Jobs"
      parameters:
        - $ref: "#/components/parameters/limitParam"
        - $ref: "#/components/parameters/offsetParam"
        - $ref: "#/components/parameters/searchParam"
        - $ref: "#/components/parameters/searchMatchParam"
        - $ref: "#/components/parameters/searchInParam"
        - $ref: "#/components/parameters/searchOrderParam"
        - $ref: "#/components/parameters/searchDirParam"
      summary: Get a list of jobs depending of the user in session with full information
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/job.yml#/components/schemas/ArrayOfDisplayJob'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /jobs/reset:
    post:
      tags:
        - "Jobs"
      summary: Set all running jobs as failed
      security:
        - BearerAuth: ['Service']
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                response:
                  type: object
      responses:
        '200':
          $ref: "#/components/responses/Success"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '500':
          $ref: "#/components/responses/ServerError"
  /jobs/{jobId}:
    parameters:
    - name: jobId
      in: path
      description: ID of the Job
      required: true
      schema:
        type: string
    get:
      tags:
        - "Jobs"
      summary: Get a job with full information
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/job.yml#/components/schemas/DisplayJobModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    delete:
      tags:
        - "Jobs"
      summary: Get a job with full information
      security:
        - BearerAuth: ['Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/job.yml#/components/schemas/DisplayJobModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    patch:
      tags:
        - "Jobs"
      summary: Change data to the job
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin', 'Service']
      requestBody:
        description: |
          Change data to the job 

            State:

              1. not-ready
              2. ready
              3. pending
              4. running
              5. stopping
              6. stopped
              7. shutting-down
              8. finished

            percentage:

            Range between -1 and 100
        content:
          application/json:
            schema:
              $ref: './schemas/job.yml#/components/schemas/UpdateJob'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/job.yml#/components/schemas/DisplayJobModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /jobs/{jobId}/config:
    get:
      tags:
        - "Project resources"
      summary: Get a specific job configuration
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          $ref: "#/components/responses/Success"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
      parameters:
      - name: jobId
        in: path
        description: ID of job
        required: true
        schema:
          type: string
    patch:
      tags:
        - "Project resources"
      summary: Restore a specific job configuration
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          $ref: "#/components/responses/Success"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
      parameters:
      - name: jobId
        in: path
        description: ID of job
        required: true
        schema:
          type: string
  /notifications:
    get:
      tags:
        - "Notifications"
      parameters:
        - $ref: "#/components/parameters/limitParam"
        - $ref: "#/components/parameters/offsetParam"
        - $ref: "#/components/parameters/searchParam"
        - $ref: "#/components/parameters/searchMatchParam"
        - $ref: "#/components/parameters/searchInParam"
        - $ref: "#/components/parameters/searchOrderParam"
        - $ref: "#/components/parameters/searchDirParam"
      summary: Get a list of notifications depending of the user in session with full information
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/notification.yml#/components/schemas/ArrayOfDisplayNotification'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    post:
      tags:
        - "Notifications"
      summary: Creating a notification
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      requestBody:
        description: Notification to be added
        content:
          application/json:
            schema:
              $ref: './schemas/notification.yml#/components/schemas/BasicNotificationModel'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/notification.yml#/components/schemas/DisplayNotificationModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /notifications/{notificationId}:
    parameters:
    - name: notificationId
      in: path
      description: ID of the notification
      required: true
      schema:
        type: string
    delete:
      tags:
        - "Notifications"
      summary: Get a notification with full information
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: './schemas/notification.yml#/components/schemas/DisplayNotificationModel'
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /notifications/seen:
    patch:
      tags:
        - "Notifications"
      summary: Mark as seen all notifications of the user in session
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  count:
                    type: number
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /open_access/datasets:
    get:
      tags:
        - "Access request"
        - datasets
      summary: Get full list of datasets available for an access request
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /open_access/datasets/{id}/metadata:
    parameters:
      - name: id
        in: path
        description: ID of the dataset
        required: true
        schema:
          type: integer
    get:
      tags:
        - "Access request"
        - dataset
        - metadata
      summary: Get Metadata for a dataset
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /access_requests/{id}/data:
    parameters:
    - name: id
      in: path
      description: ID of the access request
      required: true
      schema:
        type: number
    get:
      tags:
        - "Access request"
        - details
      summary: Get details of an access request
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin', 'Access Request Admin', 'Access Request Evaluator']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /access_requests/all:
    get:
      tags:
        - "All Access request"
      summary: Get All access requests
      security:
        - BearerAuth: ['Advanced User', 'Local Admin', 'Super Admin', 'Access Request Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /access_requests/my:
    get:
      tags:
        - "Get access request for the requestor"
      summary: Get access request for the requestor"
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /access_requests/evaluations:
    get:
      tags:
        - "Access request evaluations list"
      summary: Get access requests that have been evaluated or that are in the evaluation proccess relevant to the user
      security:
        - BearerAuth: ['Advanced User', 'Local Admin', 'Super Admin', 'Access Request Evaluator', 'Access Request Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /access_requests/{id}/evaluation:
    get:
      tags:
        - "Access request evaluation details"
      summary: Get access request evaluation details
      security:
        - BearerAuth: ['Advanced User', 'Local Admin', 'Super Admin', 'Access Request Evaluator', 'Access Request Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /access_requests/new:
    post:
      tags:
        - "new access request"
      summary: Create new access request
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin']
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                title:
                  type: string
                dataNeeded:
                  type: string
                acronym:
                  type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /access_requests/{id}/cv:
    get:
      tags:
        - "Access request get cv"
      summary: get the cv for an access request
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin', 'Access Request Evaluator', 'Access Request Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
    post:
      tags:
        - "Access request upload cv"
      summary: Upload the cv for an access request
      security:
        - BearerAuth: ['User', 'Advanced User', 'Local Admin', 'Super Admin', 'Access Request Evaluator', 'Access Request Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /access_requests/{id}/cancel:
    post:
      tags:
        - "Cancel an access request"
      summary: Cancel an access request
      security:
        - BearerAuth: ['User', 'Super Admin', 'Access Request Evaluator', 'Access Request Admin']
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"

  /access_requests/{id}/evaluation/submit:
    post:
      tags:
        - "Submit Evaluation"
      summary: Submit evaluation for an access request
      security:
        - BearerAuth: ['Advanced User', 'Local Admin', 'Super Admin', 'Access Request Evaluator', 'Access Request Admin']
      requestBody:
        content:
          application/json:
            schema:
              type: object
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
  /access_requests/{id}/revise:
    post:
      tags:
        - "Submit access request revision"
      summary: Submit access request revision
      security:
        - BearerAuth: ['User']
      requestBody:
        content:
          application/json:
            schema:
              type: object
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/Unauthenticated"
        '403':
          $ref: "#/components/responses/Unauthorized"
        '404':
          $ref: "#/components/responses/NotFound"
        '500':
          $ref: "#/components/responses/ServerError"
components:
  responses:
    File:
      description: OK
      content:
        application/zip:
          schema:
            type: string
            format: binary
    Success:
      description: OK
      content:
        application/json:
          schema:
            type: object
    BadRequest:
      description: Bad Request
      content:
        application/json:
          schema:
            $ref: "./schemas/error.yml#/components/schemas/Base"
    NotFound:
      description: The specified resource was not found
      content:
        application/json:
          schema:
            $ref: "./schemas/error.yml#/components/schemas/Base"
    Unauthorized:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: "./schemas/error.yml#/components/schemas/Base"
    Unauthenticated:
      description: Unauthenticated
      content:
        application/json:
          schema:
            $ref: "./schemas/error.yml#/components/schemas/Base"
    ServerError:
      description: Server error
      content:
        application/json:
          schema:
            $ref: "./schemas/error.yml#/components/schemas/Base"

  parameters:
    limitParam:
      in: query
      name: limit
      schema:
        type: integer
      required: false
      description: number of projects to include in the response
    offsetParam:
      in: query
      name: offset
      schema:
        type: integer
      required: false
      description: number of projects to skip from the beginning
    searchParam:
      in: query
      name: search
      schema:
        type: string
      required: false
      description: substring to filter projects by
    searchMatchParam:
      in: query
      name: match
      schema:
        $ref: "./schemas/misc.yml#/components/schemas/MatchOptions"
      required: false
      description: how to match the substring
    searchInParam:
      in: query
      name: in
      schema:
        type: string
      required: false
      description: fields to search in
    searchOrderParam:
      in: query
      name: order
      schema:
        type: string
      required: false
      description: field to order by
    searchDirParam:
      in: query
      name: dir
      schema:
        $ref: "./schemas/misc.yml#/components/schemas/SortDirection"
      required: false
      description: sort order
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
